diff options
author | Jim Meyering <jim@meyering.net> | 2006-08-19 14:01:29 +0000 |
---|---|---|
committer | Jim Meyering <jim@meyering.net> | 2006-08-19 14:01:29 +0000 |
commit | b35bd50ce62fbb98984560177198b94a7de46d00 (patch) | |
tree | 9bab2c61e3f66c9d2589b99debcb979e88d68a12 /tests/du | |
parent | 5f57935678613334bfa18ee547cb1f22a3a0a7dd (diff) | |
download | coreutils-b35bd50ce62fbb98984560177198b94a7de46d00.tar.xz |
* NEWS: Fix cp --sparse so that it preserves tail-end sparseness, even
when the file's apparent size is not a multiple of its block size.
* src/copy.c (copy_reg): Don't write a NUL before calling ftruncate.
For some file sizes, writing that single byte would unnecessarily
waste a few file blocks. That write may have been necessary in the
early days of Linux, but now, removing it should be safe.
Based on a patch by Alan Curry: <http://bugs.debian.org/370792>
* tests/cp/sparse: New test for the above.
* tests/cp/Makefile.am (TESTS): Add sparse.
* tests/sparse-file: New file, essence factored out of...
* tests/du/8gb: ... here. Use the new script.
Diffstat (limited to 'tests/du')
-rwxr-xr-x | tests/du/8gb | 16 |
1 files changed, 2 insertions, 14 deletions
diff --git a/tests/du/8gb b/tests/du/8gb index 036cb8699..0e7cfcdef 100755 --- a/tests/du/8gb +++ b/tests/du/8gb @@ -2,7 +2,7 @@ # Ensure that du does not rely on narrow types like size_t for # file sizes or sums. -# Copyright (C) 2003, 2005 Free Software Foundation, Inc. +# Copyright (C) 2003, 2005, 2006 Free Software Foundation, Inc. # This program is free software; you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by @@ -25,6 +25,7 @@ if test "$VERBOSE" = yes; then fi . $srcdir/../envvar-check +. $srcdir/../sparse-file pwd=`pwd` t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$ @@ -40,19 +41,6 @@ if test $framework_failure = 1; then (exit 1); exit 1 fi -# If this file system doesn't support sparse files, -# don't try to create a file that'd end up consuming 8GB. -# This happens on Darwin6.5 with a file system of type `hfs'. -# NTFS requires 128K before a hole appears in a sparse file. -dd bs=1 seek=128K of=t < /dev/null 2> /dev/null -set x `du -sk t` -if test "$2" -ge 128; then - echo "$0: skipping this test, since this file system doesn't support" 1>&2 - echo "$0: sparse files and this test requires a file with an apparent" 1>&2 - echo "$0: size of 8GB" 1>&2 - (exit 77); exit 77 -fi - dd bs=1 seek=8G of=big < /dev/null 2> /dev/null if test $? != 0; then echo "$0: cannot create a file large enough for this test; possibly" 1>&2 |